import type { FormKitTypeDefinition } from '@formkit/core';
import type { FormKitInputs } from '@formkit/inputs';
import { createSection, label, outer } from '@formkit/inputs';
import SchemaComponent from 'primevue/select';
import { markRaw } from 'vue';
import { floatLabel } from '../sections/floatLabel';
import { messages } from '../sections/messages';

const input = createSection('input', () => ({
  $cmp: markRaw(SchemaComponent) as never,
  bind: '$attrs',
  props: {
    invalid: '$state.invalid',
    disabled: '$disabled',
    modelValue: '$_value',
    // onValueChange: '$handlers.DOMInput',
    onBlur: '$handlers.blur',
    id: '$id',
    fluid: true,
    options: '$options',
  },
}));

export const PSelect: FormKitTypeDefinition = {
  type: 'input',
  schema: outer(
    floatLabel(
      input(), //
      label('$label'),
    ),
    messages(),
  ),
  props: ['options'],
  // schemaMemoKey: 'nnvujvlf2xr', // Math.random().toString(36).substring(2, 15)
};

declare module '@formkit/inputs' {
  // https://formkit.com/essentials/custom-inputs#typescript-support
  interface FormKitInputProps<Props extends FormKitInputs<Props>> {
    PSelect: {
      type: 'PSelect';
      options: Array<any>;
    };
  }
}
